package builtins

import (
	"git.sr.ht/~cco/go-scopes/forge"
)

type FE = forge.FE
type XT = forge.XT
type FPtr = forge.FPtr

type builtins struct {
	Add, Body, Comp, Create, Dup, Get, Lit, Mult, New1, Put, Reg, Swap, Var XT
}

func Get(f FE) *builtins {
	if v, ok := f.Voc().Lookup("builtins"); ok {
		return v.(*builtins)
	}
	b := setup(f)
	f.Voc().Register("builtins", b)
	return b
}

func setup(f FE) *builtins {
	voc := f.Voc()
	r := func(name string, fct forge.Callable) XT {
		return forge.Register(voc, forge.GoFunc(name, fct))
	}
	b := builtins{
		Add: r("+", func(f FE, _ XT) {
			f.Push(f.Pop().(int) + f.Pop().(int))
		}),
		/*Append:  r("append", func(f FE, _ XT) {
			item := f.Pop()
			f.Peek(0).(FPtr).Append(item)
		}),*/
		Body: r("body", func(f FE, _ XT) {
			f.Push(f.Pop().(XT).Code().New().Next())
		}),
		Comp:   r("comp", func(f FE, _ XT) { f.LatestXT().Code().Append(f.Pop()) }),
		Create: r("create", create),
		Dup:    r("dup", func(f FE, _ XT) { f.Push(f.Peek(0)) }),
		Get:    r("@", func(f FE, _ XT) { f.Push(f.Pop().(FPtr).Value()) }),
		Lit:    r("lit", func(f FE, _ XT) { f.Push(f.Literal()) }),
		Mult: r("*", func(f FE, _ XT) {
			f.Push(f.Pop().(int) * f.Pop().(int))
		}),
		New1: r("new1", func(f FE, _ XT) { f.Push(f.NewVar()) }),
		Put:  r("!", func(f FE, _ XT) { f.Pop().(FPtr).Set(f.Pop()) }),
		Reg:  r("reg", func(f FE, _ XT) { reg(f) }),
		Swap: r("swap", func(f FE, _ XT) {
			a := f.Pop()
			b := f.Pop()
			f.Push(a)
			f.Push(b)
		}),
		Var: r("var", func(f FE, _ XT) {
			f.Register(forge.FCode(f.Pop().(string), f.Code(f.NewVar())))
		}),
	}
	// b.Var1 = forge.Register(voc, forge.FCode("var1",
	//f.Code(b.Code, b.Swap, b.Reg, b.New1, b.Comp)))
	return &b
}

func reg(f FE) {
	f.Register(forge.FCode(f.Pop().(string), f.Pop().(FPtr).Reset()))
}

func create(f FE, _ XT) {
	name := f.Pop().(string)
	does := forge.AnonCode(f.Pop().(FPtr))
	f.Register(forge.GoFunc(name, func(f FE, _ XT) {
		f.Register(forge.FCode(f.Pop().(string),
			f.Code(f.NewVar(), does)))
	}))
}
